"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});

exports.default = function () {
  var hasDirective = function hasDirective(path, directive) {
    return !!path.findParent(function (_ref) {
      var node = _ref.node;
      return node.directives && node.directives.some(function (_ref2) {
        var value = _ref2.value;
        return value.value === directive;
      });
    });
  };

  return {
    visitor: {
      BinaryExpression: function BinaryExpression(path) {
        if (!path.isBinaryExpression({ operator: "|" })) return;
        if (hasDirective(path, "no pipe")) return;

        var rightPath = path.get("right");

        rightPath.assertCallExpression();

        rightPath.node.arguments.unshift(path.node.left);
        path.replaceWith(rightPath);

        return;
      }
    }
  };
};
